blob: cade871a2204b5bd45bea49f2b3d8624f2bd5445 [file] [log] [blame]
Matt Kraai38890782001-10-30 23:11:20 +00001#!/bin/sh
2
Denis Vlasenko3b92eaa2008-02-13 14:30:33 +00003# Usage:
4# runtest [applet1] [applet2...]
5
Denis Vlasenkoabe49fa2008-07-11 21:41:14 +00006# Helper for helpers. Oh my...
7test x"$ECHO" != x"" || {
8 ECHO="echo"
9 test x"`echo -ne`" = x"" || {
10 # Compile and use a replacement 'echo' which understands -e -n
11 ECHO="$PWD/echo-ne"
12 test -x "$ECHO" || {
13 gcc -Os -o "$ECHO" ../scripts/echo.c || exit 1
14 }
15 }
16 export ECHO
17}
18
Denis Vlasenkoe2532ab2007-12-02 01:44:42 +000019# Run one old-style test.
20# Tests are stored in applet/testcase shell scripts.
21# They are run using "sh -x -e applet/testcase".
22# Option -e will make testcase stop on the first failed command.
Denis Vlasenko018e0852007-02-25 00:40:37 +000023run_applet_testcase()
Matt Kraai38890782001-10-30 23:11:20 +000024{
Denis Vlasenko95842fb2008-04-25 08:43:01 +000025 local applet="$1"
Denis Vlasenko58dc2742008-04-23 06:45:11 +000026 local testcase="$2"
Matt Kraai38890782001-10-30 23:11:20 +000027
Denis Vlasenko81e97a12008-05-15 22:43:48 +000028 local status=0
Denis Vlasenko92a6f872008-04-27 03:33:29 +000029 local uc_applet=$(echo "$applet" | tr a-z A-Z)
30 local testname="$testcase"
Matt Kraai38890782001-10-30 23:11:20 +000031
Denis Vlasenko5d0f4aa2008-04-27 13:34:43 +000032 testname="${testname##*/}" # take basename
33 if grep "^# CONFIG_$uc_applet is not set$" "$bindir/.config" >/dev/null; then
Denis Vlasenkoe2532ab2007-12-02 01:44:42 +000034 echo "UNTESTED: $testname"
Matt Kraai38890782001-10-30 23:11:20 +000035 return 0
36 fi
37
Denis Vlasenko5d0f4aa2008-04-27 13:34:43 +000038 if grep "^# FEATURE: " "$testcase" >/dev/null; then
Denis Vlasenko95842fb2008-04-25 08:43:01 +000039 local feature=$(sed -ne 's/^# FEATURE: //p' "$testcase")
Matt Kraai38890782001-10-30 23:11:20 +000040
Denis Vlasenko5d0f4aa2008-04-27 13:34:43 +000041 if grep "^# $feature is not set$" "$bindir/.config" >/dev/null; then
Denis Vlasenkoe2532ab2007-12-02 01:44:42 +000042 echo "UNTESTED: $testname"
Matt Kraai38890782001-10-30 23:11:20 +000043 return 0
44 fi
45 fi
46
Denis Vlasenkoe2532ab2007-12-02 01:44:42 +000047 rm -rf ".tmpdir.$applet"
48 mkdir -p ".tmpdir.$applet"
49 cd ".tmpdir.$applet" || return 1
Matt Kraai38890782001-10-30 23:11:20 +000050
Denis Vlasenkoe2532ab2007-12-02 01:44:42 +000051# echo "Running testcase $testcase"
Denis Vlasenko81e97a12008-05-15 22:43:48 +000052 d="$tsdir" \
53 sh -x -e "$testcase" >"$testname.stdout.txt" 2>&1 || status=$?
Denis Vlasenko64d5bfd2008-04-26 10:14:25 +000054 if [ $status -ne 0 ]; then
Denis Vlasenkoe2532ab2007-12-02 01:44:42 +000055 echo "FAIL: $testname"
56 if [ x"$VERBOSE" != x ]; then
57 cat "$testname.stdout.txt"
Bernhard Reutner-Fischer89a22ea2006-05-25 13:24:02 +000058 fi
Matt Kraai38890782001-10-30 23:11:20 +000059 else
Denis Vlasenkoe2532ab2007-12-02 01:44:42 +000060 echo "PASS: $testname"
Matt Kraai38890782001-10-30 23:11:20 +000061 fi
62
Denis Vlasenkoe2532ab2007-12-02 01:44:42 +000063 cd ..
64 rm -rf ".tmpdir.$applet"
Matt Kraai38890782001-10-30 23:11:20 +000065
66 return $status
67}
68
Denis Vlasenkoe2532ab2007-12-02 01:44:42 +000069# Run all old-style tests for given applet
Denis Vlasenko3c07e4b2008-04-29 14:11:57 +000070run_oldstyle_applet_tests()
Matt Kraai38890782001-10-30 23:11:20 +000071{
Denis Vlasenko5d0f4aa2008-04-27 13:34:43 +000072 local applet="$1"
Matt Kraai38890782001-10-30 23:11:20 +000073 local status=0
Denis Vlasenko92a6f872008-04-27 03:33:29 +000074
75 for testcase in "$tsdir/$applet"/*; do
76 # switch on basename of $testcase
77 case "${testcase##*/}" in
Denis Vlasenko57be4ab2008-05-02 09:19:29 +000078 .*) continue ;; # .svn, .git etc
79 *~) continue ;; # backup files
80 "CVS") continue ;;
81 \#*) continue ;; # CVS merge residues
82 *.mine) continue ;; # svn-produced junk
83 *.r[0-9]*) continue ;; # svn-produced junk
Denis Vlasenko58dc2742008-04-23 06:45:11 +000084 esac
Denis Vlasenko81e97a12008-05-15 22:43:48 +000085 run_applet_testcase "$applet" "$testcase" || status=1
Matt Kraai38890782001-10-30 23:11:20 +000086 done
Matt Kraai38890782001-10-30 23:11:20 +000087 return $status
88}
89
90
Matt Kraai38890782001-10-30 23:11:20 +000091
Denis Vlasenko92a6f872008-04-27 03:33:29 +000092lcwd=$(pwd)
Denis Vlasenko7dff4332008-04-27 20:48:49 +000093[ x"$tsdir" != x ] || tsdir="$lcwd"
94[ x"$bindir" != x ] || bindir="${lcwd%/*}" # one directory up from $lcwd
Denis Vlasenko8d0a7342007-11-13 22:23:57 +000095PATH="$bindir:$PATH"
96
Denis Vlasenkoe2532ab2007-12-02 01:44:42 +000097if [ x"$VERBOSE" = x ]; then
98 export VERBOSE=
99fi
100
Matt Kraai01d2ea92002-01-02 20:37:59 +0000101if [ x"$1" = x"-v" ]; then
Denis Vlasenkoe2532ab2007-12-02 01:44:42 +0000102 export VERBOSE=1
Matt Kraai01d2ea92002-01-02 20:37:59 +0000103 shift
104fi
105
Denis Vlasenko8d0a7342007-11-13 22:23:57 +0000106implemented=$(
Denis Vlasenko92a6f872008-04-27 03:33:29 +0000107 "$bindir/busybox" 2>&1 |
Denis Vlasenko8d0a7342007-11-13 22:23:57 +0000108 while read line; do
Denis Vlasenkoe2532ab2007-12-02 01:44:42 +0000109 if [ x"$line" = x"Currently defined functions:" ]; then
Denis Vlasenko018e0852007-02-25 00:40:37 +0000110 xargs | sed 's/,//g'
111 break
112 fi
113 done
114 )
Denis Vlasenko8d0a7342007-11-13 22:23:57 +0000115
116applets="$implemented"
117if [ $# -ne 0 ]; then
118 applets="$@"
119fi
120
121# Populate a directory with links to all busybox applets
122
123LINKSDIR="$bindir/runtest-tempdir-links"
Rob Landley2824ded2006-03-16 16:02:06 +0000124rm -rf "$LINKSDIR" 2>/dev/null
125mkdir "$LINKSDIR"
Denis Vlasenko8d0a7342007-11-13 22:23:57 +0000126for i in $implemented; do
Denis Vlasenko5d0f4aa2008-04-27 13:34:43 +0000127 ln -s "$bindir/busybox" "$LINKSDIR/$i"
Rob Landley2824ded2006-03-16 16:02:06 +0000128done
129
Rob Landley48c61572005-11-07 08:50:53 +0000130# Set up option flags so tests can be selective.
Denis Vlasenko57be4ab2008-05-02 09:19:29 +0000131export OPTIONFLAGS=:$(
132 sed -nr 's/^CONFIG_//p' "$bindir/.config" |
133 sed 's/=.*//' | xargs | sed 's/ /:/g'
134 )
Rob Landley48c61572005-11-07 08:50:53 +0000135
Denis Vlasenkoe2532ab2007-12-02 01:44:42 +0000136status=0
Matt Kraai38890782001-10-30 23:11:20 +0000137for applet in $applets; do
Denis Vlasenkoe2532ab2007-12-02 01:44:42 +0000138 # Any old-style tests for this applet?
Denis Vlasenko3c07e4b2008-04-29 14:11:57 +0000139 if [ -d "$tsdir/$applet" ]; then
Denis Vlasenko81e97a12008-05-15 22:43:48 +0000140 run_oldstyle_applet_tests "$applet" || status=1
Matt Kraai38890782001-10-30 23:11:20 +0000141 fi
Rob Landley48c61572005-11-07 08:50:53 +0000142
143 # Is this a new-style test?
Denis Vlasenko5d0f4aa2008-04-27 13:34:43 +0000144 if [ -f "$applet.tests" ]; then
Denis Vlasenko95842fb2008-04-25 08:43:01 +0000145 if [ ! -h "$LINKSDIR/$applet" ]; then
146 # (avoiding bash'ism "${applet:0:4}")
147 if ! echo "$applet" | grep "^all_" >/dev/null; then
148 echo "SKIPPED: $applet (not built)"
149 continue
150 fi
Rob Landley48c61572005-11-07 08:50:53 +0000151 fi
Denis Vlasenko3c07e4b2008-04-29 14:11:57 +0000152# echo "Running test $tsdir/$applet.tests"
Denis Vlasenko81e97a12008-05-15 22:43:48 +0000153 PATH="$LINKSDIR:$tsdir:$bindir:$PATH" \
154 "$tsdir/$applet.tests" || status=1
Rob Landley16890752005-09-02 00:41:53 +0000155 fi
Matt Kraai38890782001-10-30 23:11:20 +0000156done
Denis Vlasenko4e1e7202007-11-26 05:38:20 +0000157
158# Leaving the dir makes it somewhat easier to run failed test by hand
159#rm -rf "$LINKSDIR"
160
Denis Vlasenko57be4ab2008-05-02 09:19:29 +0000161if [ $status -ne 0 ] && [ x"$VERBOSE" = x ]; then
Denis Vlasenkoe2532ab2007-12-02 01:44:42 +0000162 echo "Failures detected, running with -v (verbose) will give more info"
Denis Vlasenko4e1e7202007-11-26 05:38:20 +0000163fi
Matt Kraai38890782001-10-30 23:11:20 +0000164exit $status